*DECK EDIUPS
      SUBROUTINE EDIUPS(NGCOND,NL,NMERGE,IMR,DRSCT)
*
*-----------------------------------------------------------------------
*
* REMOVE UPSCATTERING CONTRIBUTION FROM SCATTERING MATRIX
*
* INPUT PARAMETERS:
*  NGCOND  : NUMBER OF CONDENSED GROUPS
*  NL      : NUMBER OF LEGENDRE ORDERS
*  NMERGE  : NUMBER OF MERGED REGIONS
*  IMR     : CURRENT MERGED REGION
* INPUT/OUTPUT PARAMETERS:
*  DRSCT   : DOUBLE SCATTERING MATRIX DRSCT(NGCOND,NGCOND,NL,NMERGE)
*
*-------------------------------------- AUTHOR: G. MARLEAU 97/04/02 ----
*
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='EDIUPS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          NGCOND,NL,NMERGE,IMR
      DOUBLE PRECISION DRSCT(NGCOND,NGCOND,NL,NMERGE)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          IL,JGRC,IGRC
      DO 100 IL=1,NL
        DO 110 JGRC=2,NGCOND
          DO 120 IGRC=1,JGRC-1
            DRSCT(IGRC,JGRC,IL,IMR)=DRSCT(IGRC,JGRC,IL,IMR)
     >                         -DRSCT(JGRC,IGRC,IL,IMR)
            DRSCT(JGRC,IGRC,IL,IMR)=0.0D0
 120      CONTINUE
 110    CONTINUE
 100  CONTINUE
      RETURN
      END
