*DECK MOCSAJ
      SUBROUTINE MOCSAJ(IPFLUX,NGROUP,NUN,ADJFLO)
*
*---------------------------  MOCSAJ  ---------------------------------
* 
*  1- PROGRAMME STATISTICS:
* 
*      NAME     :  MOCSAJ 
*      USE      :  SAVE ADJOINT FLUX IN IPFLUX DATA STRUCTURE
*      MODIFIED :  MONCHAI A. (10/04/04)  
* 
*  2- ROUTINE PARAMETERS:
*    INPUT
*         IPFLUX : POINTER TO FLUX FILE                    I
*                   
*         NGROUP : NUMBER OF GROUPS TREATED                I
*    
*         NUN    : NUMBER OF UNKNOWNS                      I
*         ADJFLO : REAL ARRAY OF MULTIGROUP ADJOINT FLUX   R(NUN,NGROUP)
*                  FOR DATA EXCHANGE
*    OUTPUT 
* 
* --------------------------   MOCSAJ    ------------------------------
*
      IMPLICIT NONE
      CHARACTER*12   NAMFLX
      INTEGER        IPFLUX, NUN, NGROUP, IGRP
      REAL           ADJFLO(NUN,NGROUP)
      DO 10 IGRP= 1,NGROUP
       WRITE(NAMFLX,'(4HFLUX,I3,1X)') IGRP
        CALL LCMPUT(IPFLUX,NAMFLX,NUN,2,ADJFLO(1,IGRP))
   10 CONTINUE
      RETURN
      END