      SUBROUTINE LCMGET(IPLIST,NAMP,IDATA1)
*
*-----------------------------------------------------------------------
*
* COPY A BLOCK OF DATA FROM A LINKED LIST INTO MEMORY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*
* OUTPUT PARAMETER:
*  IDATA1 : INFORMATION ELEMENTS. DIMENSION IDATA1(ILONG) WHERE ILONG
*           IS THE NUMBER OF INFORMATION ELEMENTS.
*
*------------------------------------- AUTHOR: A. HEBERT ; 25/10/93 ----
*
      PARAMETER (LHASH=251)
      INTEGER PTMP,PDATA
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JCMT=LHASH+9)
      CHARACTER NAMP*(*),NAMT*12,TEXT12*12,HSMG*131
      INTEGER IDATA1(*),INAMT(3)
      LOGICAL LCATRU,LCAFAL
      PARAMETER (LCATRU=.TRUE.,LCAFAL=.FALSE.)
      COMMON IBASE(1)
*
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMGET(IPLIST,NAMP,IDATA1)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMGET: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMGET: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 20 I=IBASE(IPNODE+2+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               PDATA=IBASE(IPNODE+10*(I-1)+JDATA)-1
               DO 10 J=1,IBASE(IPNODE+10*(I-1)+JJLON)
   10          IDATA1(J)=IBASE(PDATA+J)
               RETURN
            ENDIF
         ENDIF
      ENDIF
   20 CONTINUE
      PTMP=IBASE(IPLIST+IFATH)
      IF(PTMP.EQ.-1) THEN
         TEXT12='/'
      ELSE
         IP=IBASE(IPLIST+IDIR)
         CALL LCMCAR(TEXT12,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
      ENDIF
      WRITE(HSMG,'(30HLCMGET: UNABLE TO FIND BLOCK '',A12,9H'' INTO DI,
     1 9HRECTORY '',A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') NAMT,
     2 TEXT12,(IBASE(IPLIST+IHNAM+I),I=0,2)
      CALL XABORT(HSMG)
      END
