      SUBROUTINE XSMNXT(IPLIST,NAMP,NAMXSM,NAMMY)
*
*-----------------------------------------------------------------------
*
* FIND THE NAME OF THE NEXT BLOCK STORED IN THE ACTIVE DIRECTORY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*   NAMP  : CHARACTER*12 NAME OF A BLOCK. IF NAMP=' ' AT INPUT, FIND
*           ANY NAME FOR ANY BLOCK STORED IN THIS DIRECTORY.
*
* OUTPUT PARAMETERS:
*    NAMP : CHARACTER*12 NAME OF THE NEXT BLOCK. NAMP=' ' FOR AN EMPTY
*           DIRECTORY.
*  NAMXSM : CHARACTER*12 NAME OF THE XSM FILE.
*   NAMMY : CHARECTER*12 NAME OF THE ACTIVE DIRECTORY.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP,NAMXSM,NAMMY
      CHARACTER NAMT*12,HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      LOGICAL LBASE(1)
      COMMON IBASE(1)
      EQUIVALENCE (IBASE(1),LBASE(1))
*
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(22HXSMNXT: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         CALL XABORT(HSMG)
      ENDIF
      NAMXSM=HNAME
      WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      NAMMY=MYNAME
      NAMT=NAMP
      DO 10 J=1,IBASE(PFXSM+INMT)
      WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10 CONTINUE
      IF(NAMT.EQ.' ') THEN
         IF(IBASE(PFXSM+INMT).EQ.0) RETURN
         NAMP=CMT(1)
         RETURN
      ELSE IF(IBASE(PFXSM+INMT).EQ.0) THEN
         WRITE(HSMG,'(25HXSMNXT: EMPTY DIRECTORY '',A12,11H'' IN THE XS,
     1   8HM FILE '',A12,2H''.)') MYNAME,HNAME
         CALL XABORT(HSMG)
      ENDIF
      CALL XSMREP(NAMT,1,IBASE(PFXSM+IIFILE),LBASE(PFXSM+IMODIF),CMT,
     1 IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),
     2 MYNAME,IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),
     3 IBASE(PFXSM+IJTYP),IBASE(PFXSM+IIDIR),III)
      READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      DO 20 J=1,IBASE(PFXSM+INMT)
      READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20 CONTINUE
      IF(III.EQ.0) THEN
         WRITE(HSMG,'(30HXSMNXT: UNABLE TO FIND BLOCK '',A12,7H'' INTO ,
     1   11HDIRECTORY '',A12,19H'' IN THE XSM FILE '',A12,2H''.)') NAMT,
     2   MYNAME,HNAME
         CALL XABORT(HSMG)
      ELSE IF(III+1.LE.IBASE(PFXSM+INMT)) THEN
         NAMP=CMT(III+1)
         RETURN
      ENDIF
*
*     SWITCH TO THE NEXT DIRECTORY.
      IF(IBASE(PFXSM+IIDIR).NE.IBASE(PFXSM+ILINK)) THEN
         IF(LBASE(PFXSM+IMODIF)) THEN
            DO 30 J=1,IBASE(PFXSM+INMT)
            WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   30       CONTINUE
            WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
            CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1      IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2      IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3      IBASE(PFXSM+IIDIR))
            LBASE(PFXSM+IMODIF)=.FALSE.
         ENDIF
         IBASE(PFXSM+IIDIR)=IBASE(PFXSM+ILINK)
*        RECOVER THE NEXT DIRECTORY.
         CALL XSMDIR(1,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1   IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2   IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3   IBASE(PFXSM+IIDIR))
         READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         DO 40 J=1,IBASE(PFXSM+INMT)
         READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   40    CONTINUE
      ENDIF
      NAMP=CMT(1)
      RETURN
      END
